import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Vector;

/**
 * Lab #7
 * CS 2334, Section 0??
 * DATE GOES HERE
 * <P>
 * This class implements a data type that represents
 * a list of movies.
 * </P>
 * @author Group #??
 * @version 1.0
 */
public class MovieListModel
{
	/** List of movies */
	private ArrayList<Movie> movieList;

	/**
	 * Initializes the list model.
	 */
	MovieListModel()
	{
		movieList = new ArrayList<Movie>();
	}


	/**
	 * Adds a movie to the list.
	 * <P>
	 * @param   movie       Movie to add to the list.
	 */
	public void add( Movie movie )
	{
		movieList.add( movie );
	}

	/**
	 * Removes the specified movie from the list.
	 * <P>
	 * @param    index   Index of the movie in the list to remove.
	 */
	public void remove( int index )
	{
		movieList.remove( index );
	}

	/**
	 * Returns a vector representation of the list of movies.
	 * <P>
	 * @return   A Vector containing the movies in the list.
	 */
	@SuppressWarnings("unchecked")
	public Vector<Movie> getVector()
	{
		Vector movieVector = new Vector<Movie>();
		movieVector.addAll( movieList );
		return movieVector;
	}

	/**
	 * Save the movies to a file.
	 * <P>
	 * @param  filename     Name of the file to save the movies to.
	 * @throws IOException  Thrown when <ecode>file<ecode> cannot
	 *                      be written to.
	 */
	public void saveToFile( String filename ) throws IOException
	{
		FileOutputStream fos = new FileOutputStream( filename );
		ObjectOutputStream oos = new ObjectOutputStream( fos );

		oos.writeObject( movieList );

		oos.close();
	}

	/**
	 * Load the movies from a file.
	 * <P>
	 * @param  filename     Name of the file to load the movies from.
	 * @throws IOException  Thrown when <ecode>file<ecode> cannot
	 *                      be written to.
	 * @throws ClassNotFoundException  Thrown when a class cannot
	 *                                 be read from the specified
	 *                                 file.
	 */
	@SuppressWarnings("unchecked")
	public void loadFromFile( String filename ) 
	throws IOException, ClassNotFoundException
	{
		FileInputStream fis = new FileInputStream( filename );
		ObjectInputStream ois = new ObjectInputStream( fis );

		movieList = (ArrayList<Movie>)ois.readObject();

		ois.close();  
	}

}

